import java.sql.*;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Vector;

class BDatos {

	public static LinkedList libros;
	private Vector generos;
	private Libro l;
	private ListIterator it;
	private Connection conn;
	private Statement stlibros;
	private Statement stgen;
	private ResultSet res;
	private ResultSet gen;
	private Statement staux;
	private ResultSet rsaux;
	
	BDatos() {
		
		libros = new LinkedList();
		generos = new Vector();
		try{
			Class.forName("com.mysql.jdbc.Driver").newInstance();
			String url = "jdbc:mysql://localhost/libros_alvaro";
			String login = "root";
			String pass = "";
			conn = DriverManager.getConnection(url,login,pass);
		
			stlibros = conn.createStatement();
			stgen = conn.createStatement();

		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public void LeerDatos() {
	  
	  try {
		  res  = stlibros.executeQuery("SELECT * FROM libros");
		  gen = stgen.executeQuery("SELECT * FROM generos");
		  
		  generos.clear();
		  libros.clear();
		  
		  while(gen.next()) {
			  Genero g = new Genero(gen.getInt(1), gen.getString(2));
			  generos.add(g);
		  }
		  
		  while(res.next())
		  {
			  l = new Libro();
			  
			  l.setId(res.getInt("Id"));
			  l.setTitulo(res.getString("Titulo"));
			  l.setAutor(res.getString("Autor"));
			  l.setEditorial(res.getString("Editorial"));
			  l.setISBN(res.getString("ISBN"));
			  l.setPrestado(res.getString("Prestado"));
			  l.setComentario(res.getString("Comentario"));
			  
			  Iterator i = generos.iterator();
			  while(i.hasNext()){
				  Genero g = (Genero)(i.next());
				  if( g.getGid() == res.getInt("Genero") ){
				  	l.setGenero(g.getGenero());
				  	break;
				  }
			  }
			  libros.addLast(l);
		  }

		  it = libros.listIterator();
		  it.next();		  
		
	  } catch (Exception e) {
		  e.printStackTrace();
		  return;
	  }
  	}
	
	public Libro siguiente(Libro l) {
		Libro l2;
		if(it.hasNext()) {
			l2 = (Libro)(it.next());
			if(l2 == l || l==null)
				l2 = (Libro)(it.next());
			return l2;
		}
		else
			return null;	
	}
	
	public Libro anterior(Libro l) {
		Libro l2;
		if(it.hasPrevious()) {
			l2 = (Libro)(it.previous());
			if( (l2 == l) || l==null)
				l2 = (Libro)(it.previous());
			return l2;
		}
		else 
			return null;
	}
	
	public void cambiaLibro(Libro l) {
		System.out.println("Cambio");
		int id = l.getId();
		try{
			// Actualizamos la base de datos
			
			stlibros.executeUpdate("update libros set Titulo='" + l.getTitulo() +"' where id='" + l.getId() + "'");
			stlibros.executeUpdate("update libros set Autor='" + l.getAutor() +"' where id='" + l.getId() + "'");
			stlibros.executeUpdate("update libros set Editorial='" + l.getEditorial() +"' where id='" + l.getId() + "'");
			stlibros.executeUpdate("update libros set Prestado='" + l.getPrestado() +"' where id='" + l.getId() + "'");
			stlibros.executeUpdate("update libros set Comentario='" + l.getComentario() +"' where id='" + l.getId() + "'");
			stlibros.executeUpdate("update libros set ISBN='" + l.getISBN() +"' where id='" + l.getId() + "'");
			
			// Obtenemos el genero de la bd
			staux = conn.createStatement();
			rsaux = staux.executeQuery("select Id from generos WHERE Genero ='" + l.getGenero() + "'");
			rsaux.next();
			int gid = rsaux.getInt(1);
			stlibros.executeUpdate("update libros set Genero='" + gid +"' where id='" + l.getId() + "'");
			rsaux.close();
			staux.close();
			
			// Actualizamos la LinkedList libros
			for(int i=0;i<libros.size();i++){
				if( ((Libro)(libros.get(i))).getId() == id ) {
					libros.set(i,l);
					break;
				}
				
			}
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void nuevoLibro(Libro l) {
		String in;
		int gid = 1;
		
		in = "insert into libros (Titulo,Autor,Editorial,Prestado,Comentario,ISBN,Genero) values('" + l.getTitulo() + "','" + l.getAutor() + "','";
		in = in + l.getEditorial() + "','" + l.getPrestado() + "','" + l.getComentario() + "','" + l.getISBN() + "','";
		
		try {
//		 	Obtenemos el genero de la bd
			staux = conn.createStatement();
			rsaux = staux.executeQuery("select Id from generos WHERE Genero ='" + l.getGenero() + "'");
			rsaux.next();
			gid = rsaux.getInt(1);
			staux.close();
			rsaux.close();
		} catch (Exception e){
			e.printStackTrace();
		}
		
		in = in + gid + "')";
		
		try{
			stlibros.executeUpdate(in);
		} catch(Exception e){
			e.printStackTrace();
		}
		
	}
	public void cerrar() {
		try {
			res.close();
			gen.close();
			stlibros.close();
			stgen.close();		  
			conn.close();
		} catch(SQLException e) {
			e.printStackTrace();
		}
	}
	
	public Vector getGenerosStrings() {
		Iterator i = generos.iterator();
		Vector v = new Vector();
		
		while(i.hasNext())
		{
			Genero g = (Genero)(i.next());
			v.add(g.getGenero());
			
		}
		
		//System.out.println(v);
		return v;
	}
}

