import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class VPrincipal extends JFrame {
	
	private BDatos j = new BDatos();
	private JTextField txtTitulo;
	private JTextField txtAutor;
	private JTextField txtEditorial;
	private JTextField txtPrestado;
	private JTextArea  txtComentario;
	private JTextField txtISBN;
	private JTextField txtGenero;
	private JComboBox  cmbGenero;
	
	private JButton btnBuscaTitulo;
	private JButton btnSiguiente;
	private JButton btnAnterior;
	private JButton btnCambiar;
	private JButton btnNuevo;
	Libro l;
	boolean cambio = false;
	boolean nuevo = false;
	
	VPrincipal() {
		super("Gestión de Libros");
		Container c = getContentPane();
		c.setLayout(new FlowLayout());
		
		j.LeerDatos();
		
		// Inicializar componentes
		txtTitulo = new JTextField(20);
		txtTitulo.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cambio = true;
				l.setTitulo(txtTitulo.getText());
			}	
		});
		
		txtAutor = new JTextField(20);
		txtAutor.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cambio = true;
				l.setAutor(txtAutor.getText());
			}
		});
		txtEditorial = new JTextField(20);
		txtEditorial.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cambio = true;
				l.setEditorial(txtEditorial.getText());
			}
		});
		txtPrestado = new JTextField(20);
		txtPrestado.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cambio=true;
				l.setPrestado(txtPrestado.getText());
			}
		});
		txtComentario = new JTextArea(10,20);
		
		txtISBN = new JTextField(20);
		txtISBN.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				cambio=true;
				l.setISBN(txtISBN.getText());
			}
		});
		
		cmbGenero = new JComboBox(j.getGenerosStrings());
		cmbGenero.addItemListener(new ItemListener(){
			public void itemStateChanged(ItemEvent e) {
				cambio=true;
				l.setGenero( ((String)e.getItem()) );
			}
		});
		
		btnBuscaTitulo = new JButton("Buscar");
		btnBuscaTitulo.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				System.out.println(buscar("Título"));
			}
		});
		btnAnterior = new JButton("Anterior");
		btnAnterior.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				if(cambio)
					j.cambiaLibro(l);
				cambio=false;
				if(nuevo) {
					j.nuevoLibro(l);
					nuevo = false;
				}
				anterior();
			}
		});
		btnSiguiente = new JButton("Siguiente");
		btnSiguiente.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e){
				if(cambio)
					j.cambiaLibro(l);
				if(nuevo) {
					j.nuevoLibro(l);
					nuevo = false;
				}
				cambio=false;
				siguiente();
				
			}
		});
		
		btnNuevo = new JButton("Nuevo libro");
		btnNuevo.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e){
				nuevoLibro();
			}
		});
		
		/*btnCambiar = new JButton("Cambiar Registro");
		btnCambiar.addMouseListener(new MouseAdapter() {
			public void mousePressed(MouseEvent e) {
				if(cambio)
					j.cambiaLibro(l);
				cambio=false;
			}
		});*/
		
		// Acciones previas
		l = (Libro)(BDatos.libros.getFirst());
		cargaLibro(l);
		
		// Añadimos componentes
		JPanel pTitulo = new JPanel();
		pTitulo.add(new JLabel("Título:"));
		pTitulo.add(txtTitulo);
		pTitulo.add(btnBuscaTitulo);
		c.add(pTitulo);
		
		JPanel pAutor = new JPanel();
		pAutor.add(new JLabel("Autor:"));
		pAutor.add(txtAutor);
		c.add(pAutor);
		
		JPanel pEditorial = new JPanel();
		pEditorial.add(new JLabel("Editorial:"));
		pEditorial.add(txtEditorial);
		c.add(pEditorial);
		
		JPanel pPrestado = new JPanel();
		pPrestado.add(new JLabel("Prestado a:"));
		pPrestado.add(txtPrestado);
		c.add(pPrestado);
		
		JPanel pComentario = new JPanel();
		pComentario.add(new JLabel("Comentario:"));
		JScrollPane jspCom = new JScrollPane(txtComentario);
		pComentario.add(jspCom);
		c.add(pComentario);
		
		JPanel pISBN = new JPanel();
		pISBN.add(new JLabel("ISBN:"));
		pISBN.add(txtISBN);
		c.add(pISBN);
		
		JPanel pGenero = new JPanel();
		pGenero.add(new JLabel("Género:"));
		//pGenero.add(txtGenero);
		pGenero.add(cmbGenero);
		c.add(pGenero);
		
		JPanel pNavega = new JPanel();
		pNavega.add(btnAnterior);
		pNavega.add(btnSiguiente);
		c.add(pNavega);
		
		c.add(btnNuevo);
		//c.add(btnCambiar);
		
		addWindowListener(new WindowAdapter(){
			public void windowClosing(WindowEvent e){
				if(cambio)
					j.cambiaLibro(l);
				if(nuevo) {
					j.nuevoLibro(l);
					nuevo = false;
				}
				System.exit(0);
			}
		});
		//setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setSize(400,500);
		setResizable(false);
		setVisible(true);	
	}
	
	public void siguiente(){
		Libro l2;
		l2 = j.siguiente(l);
		if(l2 != null){
			l = l2;
			cargaLibro(l);
		}
	}
	
	public void anterior(){
		Libro l2;
		l2 = j.anterior(l);
		if(l2 != null) {
			l = l2;
			cargaLibro(l);
		}
	}
	
	public void cargaLibro(Libro l){
		if (l != null) {
			cambio = false;
			txtTitulo.setText(l.getTitulo());
			txtAutor.setText(l.getAutor());
			txtEditorial.setText(l.getEditorial());
			txtPrestado.setText(l.getPrestado());
			txtComentario.setText(l.getComentario());
			txtISBN.setText(l.getISBN());
			cmbGenero.setSelectedItem(l.getGenero());
		}
	}
	
	public void nuevoLibro() {
		l = new Libro();
		nuevo = true;
		cargaLibro(l);
	}
	
	public String buscar(String q) {
		return JOptionPane.showInputDialog(null,
				q+":",
				"Buscar " + q,
				JOptionPane.OK_OPTION);
	}

}
